import java.awt.Graphics;
import java.awt.Color;
import javax.swing.*;
/**
  *
  * Beschreibung
  *
  * @version 1.0 vom 16.05.2011
  * @author Daniel Garmann
  */

public class SpielClient extends Client {

  // Anfang Attribute
  private Graphics anzeige;
  private Gui gui;
  private String nickname;
  private int status = 0; // 0: name eingeben 1: gejoint, 2: spiel gestartet, 3: wuerfeln oder karte nehmen mglich, 4: Wrfelauswahl mglich
  // Ende Attribute

  public SpielClient(String pServerIP, int pServerPort, Gui gui, String nickname) {
    super(pServerIP, pServerPort);
    this.gui = gui;
    this.nickname = nickname;
  }
  // Anfang Methoden


  public void starten() {
    this.send("PLAY");
  }
  
  public void bereitErklaeren(boolean value) {
    if (value == true)
      this.send("JOIN");
  }
  
  public void chatten(String text) {
    this.send("SEND "+text);
  }

  public void fluestern(String nick, String text) {
    this.send("WHIS "+nick+":"+text);
  }

  public void wuerfeln() {
    this.send("TOSS");
  }
  
  public void rausnehmen(int augen) {
    this.send("SAVE "+augen);
  }
  
  public void kartenehmen(int karte) {
    status = 4;
    this.send("TAKE "+karte);
  }
  
  public void nicksabfragen() {
    this.send("NICK");
  }

  public void playersabfragen() {
    this.send("LIST");
  }

  
  public void spielfeldabfragen() {
    this.send("DATA");
  }
  
  public void resetschicken() {
    this.send("RSET");
  }

  public void resetbestaetigen(boolean value) {
    if (value == true) this.send("YRST");
    else this.send("NRST");
  }

  private void chatanzeigen(String text) {
    gui.jtaChat.append(text+"\n");
    gui.jtaChat.select(gui.jtaChat.getText().length(),gui.jtaChat.getText().length());
  }
  

  public void processMessage(String message) {
    System.out.println("Client empfngt: "+message);

    if (message.startsWith("NAME")) {
      send("NAME "+nickname);
    } else if (message.startsWith("SEND")) {
      chatanzeigen(message.substring(5));
    } else if (message.startsWith("WHIS")) {
      chatanzeigen("Flstern ---- "+message.substring(5));
    } else if (message.startsWith("NICK")) {
      String[] nicks = message.substring(5).split(",");
      gui.jtaTeilnehmerListe.setText("");
      for (int i = 0; i < nicks.length; i++) {
        gui.jtaTeilnehmerListe.append(nicks[i]+"\n");
      }
    } else if (message.startsWith("LIST")) {
      String[] nicks = message.substring(5).split(",");
      gui.jtaSpielerListe.setText("");
      for (int i = 0; i < nicks.length; i++) {
        gui.jtaSpielerListe.append(nicks[i]+"\n");
      }
    } else if (message.startsWith("DATA")) {
      gui.spielfeldausgabe(message.substring(5));
      gui.jbReset.setEnabled(true);
      gui.jbResetYes.setEnabled(false);
      gui.jbResetNo.setEnabled(false);
      gui.jbLos.setEnabled(false);
    } else if (message.startsWith("OK04")) {
      gui.wuerfelbuttonsSichtbarMachen(true);
    } else if (message.startsWith("OK05")) {
      gui.wuerfelbuttonsSichtbarMachen(false);
    } else if (message.startsWith("ER01")) {
      chatanzeigen(message.substring(5));
      this.close();
    } else if (message.startsWith("ER02")) {
      chatanzeigen(message.substring(5));
      gui.jcbBereit.setSelected(false);
    } else if (message.startsWith("ER03")) {
      chatanzeigen(message.substring(5));
    } else if (message.startsWith("ER04")) {
      chatanzeigen(message.substring(5));
      gui.wuerfelbuttonsSichtbarMachen(false);
    } else if (message.startsWith("ER04")) {
      chatanzeigen(message.substring(5));
      gui.wuerfelbuttonsSichtbarMachen(true);
    } else if (message.startsWith("RSET")) {
      chatanzeigen("Resetwunsch von "+ message.substring(5));
      gui.jbReset.setEnabled(false);
      gui.jbResetYes.setEnabled(true);
      gui.jbResetNo.setEnabled(true);
    } else if (message.startsWith("ENDE")) {
      JOptionPane.showMessageDialog(gui, "Sieger: "+message.substring(5));
      gui.jbLos.setEnabled(true);
    }
  }
  


  // Ende Methoden
}
