/**
  *
  * Beschreibung
  *
  * @version 1.0 vom 24.03.2009
  * @author
  */

public class TeilnehmerListe {

  // Anfang Variablen
  private List liste;
  // Ende Variablen

  public TeilnehmerListe() {
    liste = new List();
  }

  // Anfang Ereignisprozeduren
  public boolean hinzufuegen(String ip, int port, String nick) {
    Teilnehmer teilnehmer = new Teilnehmer(ip, port, nick);
    if (gibPort(nick) == -1) {
      liste.toLast();
      liste.insert(teilnehmer);
      liste.next();
      return true;
    } else {
      return false;
    }
  }

  public boolean entfernen(String nick) {
    if (this.gibPort(nick) != -1) {
      liste.remove();
      return true;
    } else {
      return false;
    }
  }
  
  public boolean entfernen(String ip, int port) {
    if (this.gibName(ip, port) != null) {
      liste.remove();
      return true;
    } else {
      return false;
    }
  }
  
  public int spielbeitreten(String ip, int port) {
    Teilnehmer t = this.gibTeilnehmer(ip, port);
    if (t.getSpielernr() > -1) {
      return t.getSpielernr();
    }
    // maximale Spielernr suchen
    int max = spieleranzahl();

    // prfen, ob alle Spielernr. bis max vergeben sind, wenn nicht, dann setzen
    for (int i = 0; i <= max; i++) {
      boolean vorhanden = false;
      for (liste.toFirst(); liste.hasAccess(); liste.next()) {
        if ( ((Teilnehmer)liste.getObject()).getSpielernr() == i) {
          vorhanden = true;
        }
      }
      if (!vorhanden) {
        t.setSpielernr(i);
        return i;
      }
    }
    return -1;
  }
  
  public int spieleranzahl() {
    int max = -1;
    for (liste.toFirst(); liste.hasAccess(); liste.next()) {
      if ( ((Teilnehmer)liste.getObject()).getSpielernr() > max ) {
        max =((Teilnehmer)liste.getObject()).getSpielernr();
      }
    }
    return max + 1;
  }
  
  public boolean spielverlassen(String ip, int port) {
    Teilnehmer t = this.gibTeilnehmer(ip, port);
    if (t.getSpielernr() > -1) {
      t.setSpielernr(-1);
      return true;
    } else {
      return false;
    }
  }
  
  public String gibIP(String name) {
    for (liste.toFirst(); liste.hasAccess(); liste.next()) {
      if (((Teilnehmer)liste.getObject()).getNick().equals(name))
        return ((Teilnehmer)liste.getObject()).getIP();
    }
    return null;
  }

  public int gibPort(String name) {
    for (liste.toFirst(); liste.hasAccess(); liste.next()) {
      if (((Teilnehmer)liste.getObject()).getNick().equals(name))
        return ((Teilnehmer)liste.getObject()).getPort();
    }
    return -1;
  }

  public String gibName(String ip, int port) {
    for (liste.toFirst(); liste.hasAccess(); liste.next()) {
      if (((Teilnehmer)liste.getObject()).getIP().equals(ip) &&
          ((Teilnehmer)liste.getObject()).getPort() == port)
        return ((Teilnehmer)liste.getObject()).getNick();
    }
    return null;
  }
  
  public Teilnehmer gibTeilnehmer(String ip, int port) {
    for (liste.toFirst(); liste.hasAccess(); liste.next()) {
      if (((Teilnehmer)liste.getObject()).getIP().equals(ip) &&
          ((Teilnehmer)liste.getObject()).getPort() == port)
        return ((Teilnehmer)liste.getObject());
    }
    return null;
  }
  
  public Teilnehmer gibTeilnehmer(int spielernr) {
    for (liste.toFirst(); liste.hasAccess(); liste.next()) {
      if (((Teilnehmer)liste.getObject()).getSpielernr() == spielernr)
        return ((Teilnehmer)liste.getObject());
    }
    return null;
  }
  
  public String toString() {
    String result = "";
    for (liste.toFirst(); liste.hasAccess(); liste.next()) {
      result = result +"," + ((Teilnehmer)liste.getObject()).getNick();
    }
    return result.substring(1);
  }

  public String spielerliste() {
    String result = "";
    for (liste.toFirst(); liste.hasAccess(); liste.next()) {
      if (((Teilnehmer)liste.getObject()).getSpielernr()>=0) {
        result = result +"," + ((Teilnehmer)liste.getObject()).getNick()+"-"+((Teilnehmer)liste.getObject()).getSpielernr();
      }
    }
    if (result.equals("")) return "";
    else return result.substring(1);
  }

  public boolean allReset() {
    for (liste.toFirst(); liste.hasAccess(); liste.next()) {
      Teilnehmer t = (Teilnehmer)liste.getObject();
      if (t.getSpielernr()>=0) {
        System.out.println(t.getNick());
        if (t.getReset() == false) return false;
      }
    }
    return true;
  }

  public void setAllReset(boolean value) {
    for (liste.toFirst(); liste.hasAccess(); liste.next()) {
      Teilnehmer t = (Teilnehmer)liste.getObject();
      if (t.getSpielernr()>=0) {
        t.setReset(value);
      }
    }
  }
  // Ende Ereignisprozeduren
}

